SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'EzequielBarrios 4/29/2013 20:16'!
blueGhost

	|aPacmanGame|
	aPacmanGame := PacManGame new.
	^ aPacmanGame blueGhost! !

!PacManTest methodsFor: 'actors' stamp: 'EzequielBarrios 4/29/2013 21:00'!
blueberry

	|aPacmanGame|
	aPacmanGame := PacManGame new.
	^ aPacmanGame blueBerry! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:57'!
down

	^0@(-1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 21:19'!
ghostHouseDoorType

	^ GhostHouseDoorCellType new! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:58'!
left

	^ (-1)@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 5/16/2012 16:33'!
leftTransporterType

	self shouldBeImplemented ! !

!PacManTest methodsFor: 'actors' stamp: 'EzequielBarrios 4/29/2013 21:00'!
pacman

	|aPacmanGame|
	aPacmanGame := PacManGame new.
	^ aPacmanGame pacman! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:57'!
right

	^1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 21:05'!
spaceType

		^ SpaceCellType new 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:58'!
up

	^ 0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 20:41'!
wallType

	^ WallCellType new ! !

Object subclass: #PacManCell
	instanceVariableNames: 'pacmanGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacManCell subclass: #GhostHouseDoorCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorCellType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:45'!
nextPositionFor: anActor going: aDirection
	 ^ anActor type nextPositionGoingToGhostHouseDoorFor: anActor inDirection: aDirection! !

PacManCell subclass: #SpaceCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceCellType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:43'!
nextPositionFor: anActor going: aPoint 
	^ anActor position + aPoint.! !

PacManCell subclass: #WallCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallCellType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:43'!
nextPositionFor: anActor going: aDirection

	^ anActor position! !

Object subclass: #PacManGame
	instanceVariableNames: 'pacman blueGhost blueBerry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManGame methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:12'!
blueBerry
	^ blueBerry! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 20:16'!
blueGhost
	^ blueGhost! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:16'!
initialize

	super initialize.
	pacman := Pacman new.
	pacman initializeWithX: 40 andY: 1.
	blueGhost := Ghost new.
	blueGhost initializeWithX: 20 andY: 20.
	blueBerry := Fruit new.
	blueBerry initializeWithX: 15 andY: 35.! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:35'!
nextPositionGoingToGhostHouseDoorFor: anActor inDirection: aDirection
	
	^ anActor actorType nextPositionGoingToGhostHouseDoorFor: anActor inDirection: aDirection
! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:00'!
pacman
	^ pacman! !

Object subclass: #PacmanActor
	instanceVariableNames: 'position type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacmanActor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 20:27'!
initializeWithX: xPosition andY: yPosition

	super initialize.
	position := Point x: xPosition y: yPosition.! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:32'!
type
	^ FruitType new! !

PacmanActor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 20:27'!
initializeWithX: xPosition andY: yPosition

	super initialize.
	position := Point x: xPosition y: yPosition.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:31'!
type
	^ GhostType new! !

PacmanActor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 20:28'!
initializeWithX: xPosition andY: yPosition

	super initialize.
	position := Point x: xPosition y: yPosition.! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:32'!
type
	^ PacmanType new! !

!PacmanActor methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:30'!
position
	^ position! !

!PacmanActor methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:30'!
type
	self subclassResponsibility ! !

Object subclass: #PacmanActorType
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacmanActorType subclass: #FruitType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!FruitType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:37'!
nextPositionGoingToGhostHouseDoorFor: aFruit inDirection: aDirection
	
	^ aFruit position + aDirection ! !

PacmanActorType subclass: #GhostType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:37'!
nextPositionGoingToGhostHouseDoorFor: aGhost inDirection: aDirection
	
	^ aGhost position + aDirection ! !

PacmanActorType subclass: #PacmanType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacmanType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:38'!
nextPositionGoingToGhostHouseDoorFor: aPacman inDirection: aDirection
	
	^ aPacman position! !
